export const vietnamAccentUpper = "ĂÂÀÁẢÃẠẰẮẲẴẶẦẤẨẪẬÔƠÒÓỎÕỌỒỐỔỖỘỜỚỞỠỢÈÉẺẼẸÊỀẾỂỄỆÙÚỦŨỤƯỪỨỬỮỰÌÍỈĨỊỲÝỶỸỴĐ";
export const vietnamNoAccentUpper = "AAAAAAAAAAAAAAAAAOOOOOOOOOOOOOOOOOEEEEEEEEEEEUUUUUUUUUUUIIIIIYYYYYD";
export const vietnamAccentLower = vietnamAccentUpper.toLowerCase();
export const vietnamNoAccentLower = vietnamNoAccentUpper.toLowerCase();
export const latinaAccent = "ŠšŽžÄÅÆÇËÎÏÑÖØÛÜŸÞäåæçëîïñõöøûüÿþƒ";
export const latinaNoAccent = "SsZzAAACEIINOOUUYBaaaceiinooouuybf";
const accentCharsets = [
    { accent: vietnamAccentUpper, noAccent: vietnamNoAccentUpper },
    { accent: vietnamAccentLower, noAccent: vietnamNoAccentLower },
    { accent: latinaAccent, noAccent: latinaNoAccent },
];
export const removeAccent = (data) => {
    let result = "";
    for (let i = 0; i < data.length; i++) {
        let character = data[i];
        for (const charset of accentCharsets) {
            const indexOf = charset.accent.indexOf(character);
            if (indexOf >= 0) {
                character = charset.noAccent[indexOf];
                break;
            }
        }
        result += character;
    }
    return result;
};
export const searchCompare = (value, search, ignoreValueAccent = true) => {
    return (ignoreValueAccent ? removeAccent(value) : value).toLowerCase().includes(removeAccent(search).toLowerCase());
};
