export type Constructor<T> = {
    new (...args: any[]): T;
};
export type AbstractConstructor<T> = Function & {
    prototype: T;
};
export type PrimitiveConstructors = "String" | "Number" | "Boolean";
export type PrimitiveType = number | string | boolean;
export type PrimitiveArray = number[] | string[] | boolean[];
export type Optional<T, K extends keyof T> = Pick<Partial<T>, K> & Omit<T, K>;
