import { SerializedValueProvider } from "./request-serializer";
export type CacheRecord<T, K extends string | number> = Record<K, {
    lastFetchTimestamp: number;
    value?: T;
} | undefined>;
export declare class CachedDataContainer<T, K extends any[]> {
    protected readonly valueGetterFn: (...args: K) => Promise<T | undefined>;
    protected readonly valueSetterFn?: ((value: T, ...args: K) => Promise<void>) | undefined;
    protected readonly dataRetentionDurationMs: number;
    protected readonly cache: CacheRecord<T, string>;
    protected readonly valueProvider: SerializedValueProvider<T | undefined, K>;
    constructor(valueGetterFn: (...args: K) => Promise<T | undefined>, valueSetterFn?: ((value: T, ...args: K) => Promise<void>) | undefined, dataRetentionDurationMs?: number);
    getValue(...args: K): Promise<T | undefined>;
    setValue(value: T, ...args: K): Promise<void>;
}
