import { Constructor } from "../common/types";
import { DtoFieldMetadata, DtoMetadata } from "../dto/DtoMetadata";
import { GetManyQueries, GetManyResponseBody } from "./request-response";
import { ModelMetadata } from "../model/ModelMetadata";
export declare const getCreateManyBodyValidator: (modelMetadata: DtoMetadata) => DtoMetadata;
export declare const getCreateManyResponseValidator: (modelMetadata: ModelMetadata) => DtoMetadata;
export declare const getGetManyResponseValidator: (modelMetadata: ModelMetadata) => DtoMetadata;
export declare const getBodyDtoRecordClass: (modelMetadata: DtoMetadata, operation: "query" | "get_response" | "create_body" | "create_response" | "update_body", parentModelMetadata?: DtoMetadata) => DtoMetadata;
export declare const projectionFieldDto: (modelMetadata: DtoMetadata) => DtoFieldMetadata;
export declare const getRequestQueryFieldFromModel: (modelMetadata: DtoMetadata) => DtoFieldMetadata[];
export declare const queryFieldDto: (modelMetadata: DtoMetadata) => DtoFieldMetadata;
export declare const getGetManyQueryValidator: (modelMetadata: DtoMetadata) => DtoMetadata;
export declare const getUpdateManyQueryValidator: (modelMetadata: ModelMetadata) => DtoMetadata;
export declare const getUpdateManyBodyValidator: (modelMetadata: ModelMetadata) => DtoMetadata;
export declare const getUpdateManyResponseValidator: (modelMetadata: ModelMetadata) => DtoMetadata;
export declare const getUpdateRecordsQueryValidator: () => DtoMetadata;
export declare const getUpdateRecordsBodyValidator: (modelMetadata: ModelMetadata) => DtoMetadata;
export declare const GetManyResponseBodyClass: <T>(cls: Constructor<T>) => Constructor<GetManyResponseBody<T>>;
export declare const GetManyQueriesClass: <T>(cls: Constructor<T>) => Constructor<GetManyQueries<T>>;
