var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { DataType } from "../common/DataType";
import { getObjectMetadata } from "../common/metadata";
import { Enum } from "../dto/decorator";
import { Data, Field } from "../dto/decorator";
import { HttpMethod } from "./HttpMethod";
let ApiInfo = class ApiInfo {
    id;
    apiGroup;
    description;
    name;
    readOnly;
    method;
    mount;
    paramDto;
    queryDto;
    bodyDto;
    responseDto;
    upstreamMessageDtos;
    downstreamMessageDtos;
};
__decorate([
    Field({
        description: "Unique id of the API within the service",
        isRequired: true,
    }),
    __metadata("design:type", String)
], ApiInfo.prototype, "id", void 0);
__decorate([
    Field({
        description: "Name of the api group",
    }),
    __metadata("design:type", String)
], ApiInfo.prototype, "apiGroup", void 0);
__decorate([
    Field({
        description: "Description of the API",
    }),
    __metadata("design:type", String)
], ApiInfo.prototype, "description", void 0);
__decorate([
    Field({
        description: "Display name of the API",
        isRequired: true,
    }),
    __metadata("design:type", String)
], ApiInfo.prototype, "name", void 0);
__decorate([
    Field({
        description: "Whether this API does not allow data modification",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], ApiInfo.prototype, "readOnly", void 0);
__decorate([
    Field({
        description: "Http method used to call the API",
        isRequired: true,
        ...Enum(HttpMethod),
    }),
    __metadata("design:type", String)
], ApiInfo.prototype, "method", void 0);
__decorate([
    Field({
        description: "Http mount point of the API",
        isRequired: true,
    }),
    __metadata("design:type", String)
], ApiInfo.prototype, "mount", void 0);
__decorate([
    Field({
        description: "Validation dto of request param",
    }),
    __metadata("design:type", Object)
], ApiInfo.prototype, "paramDto", void 0);
__decorate([
    Field({
        description: "Validation dto of request queries",
    }),
    __metadata("design:type", Object)
], ApiInfo.prototype, "queryDto", void 0);
__decorate([
    Field({
        description: "Validation dto of request body",
    }),
    __metadata("design:type", Object)
], ApiInfo.prototype, "bodyDto", void 0);
__decorate([
    Field({
        description: "Validation dto of response body",
    }),
    __metadata("design:type", Object)
], ApiInfo.prototype, "responseDto", void 0);
__decorate([
    Field({
        description: "Messages send from client to server for socket",
    }),
    __metadata("design:type", Array)
], ApiInfo.prototype, "upstreamMessageDtos", void 0);
__decorate([
    Field({
        description: "Messages send from server to client for socket",
    }),
    __metadata("design:type", Array)
], ApiInfo.prototype, "downstreamMessageDtos", void 0);
ApiInfo = __decorate([
    Data()
], ApiInfo);
export { ApiInfo };
let ApiInfoResponse = class ApiInfoResponse {
    apis;
};
__decorate([
    Field({
        description: "All APIs of the service",
        isRequired: true,
        elementDto: getObjectMetadata(ApiInfo),
        vectorProps: { elementDataType: DataType.OBJECT },
    }),
    __metadata("design:type", Array)
], ApiInfoResponse.prototype, "apis", void 0);
ApiInfoResponse = __decorate([
    Data()
], ApiInfoResponse);
export { ApiInfoResponse };
