import { DeepPartial } from "../dto/deep-partial";
import { Identifiable } from "../model/Identifiable";
export type OrderDirection = "desc" | "asc";
export type OrderDirective<K> = {
    [k in keyof K]?: OrderDirection;
}[] | "random";
export type GetManyQueryCondition<T> = {
    [k in keyof T]?: T[k] extends Identifiable ? GetManyQueryCondition<T[k]> : T[k] extends Identifiable[] ? GetManyQueryCondition<T[k][number]> : any;
};
export declare class FieldsQuery<T> {
    fields?: GetManyQueryCondition<T>;
}
export declare class CreateManyRequestBody<T> {
    records: DeepPartial<T>[];
}
export declare class CreateManyResponseBody<T> {
    records: DeepPartial<T>[];
}
export declare class IdParam {
    id: string;
}
export declare class PaginationQueries {
    limit?: number;
    page?: number;
}
export declare class SearchQueries {
    search?: string;
}
export declare class LocaleQueries {
    locale?: string;
}
export declare class ReturningQueries {
    returning?: boolean;
}
declare const GetManyQueries_base: import("..").Constructor<PaginationQueries & SearchQueries & LocaleQueries>;
export declare class GetManyQueries<T> extends GetManyQueries_base {
    fields?: GetManyQueryCondition<T>;
    order?: OrderDirective<T>;
    projection?: (keyof T)[];
}
export declare class GetManyResponseBody<T> {
    total: number;
    records: DeepPartial<T>[];
}
export declare class UpdateManyQueries<T> extends ReturningQueries {
    fields?: GetManyQueryCondition<T>;
}
export declare class UpdateManyResponse<T> {
    modified: DeepPartial<T>[];
}
export declare class UpdateManyBody<T> {
    update: DeepPartial<T>;
}
export declare class UpdateRecordsBody<T extends Identifiable, K extends keyof T> {
    records: Partial<Pick<T, "id" | K>>[];
}
export {};
