var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { DataType } from "../common/DataType";
import { Data, Field } from "../dto/decorator";
import { select } from "../dto/combine";
let FieldsQuery = class FieldsQuery {
    fields;
};
__decorate([
    Field({
        description: "Filter records by fields.",
    }),
    __metadata("design:type", Object)
], FieldsQuery.prototype, "fields", void 0);
FieldsQuery = __decorate([
    Data({ relaxed: true })
], FieldsQuery);
export { FieldsQuery };
//-- create
let CreateManyRequestBody = class CreateManyRequestBody {
    records = [];
};
__decorate([
    Field({
        description: "Records to create",
        isRequired: true,
        vectorProps: { minLength: 1 },
    }),
    __metadata("design:type", Array)
], CreateManyRequestBody.prototype, "records", void 0);
CreateManyRequestBody = __decorate([
    Data()
], CreateManyRequestBody);
export { CreateManyRequestBody };
let CreateManyResponseBody = class CreateManyResponseBody {
    records = [];
};
__decorate([
    Field({
        description: "Returned records",
        isRequired: true,
    }),
    __metadata("design:type", Array)
], CreateManyResponseBody.prototype, "records", void 0);
CreateManyResponseBody = __decorate([
    Data()
], CreateManyResponseBody);
export { CreateManyResponseBody };
let IdParam = class IdParam {
    id;
};
__decorate([
    Field({
        description: "Id of the record",
        isRequired: true,
    }),
    __metadata("design:type", String)
], IdParam.prototype, "id", void 0);
IdParam = __decorate([
    Data({ relaxed: true })
], IdParam);
export { IdParam };
let PaginationQueries = class PaginationQueries {
    limit;
    page;
};
__decorate([
    Field({
        description: "Limit the result.",
        rangeProps: { min: 1 },
    }),
    __metadata("design:type", Number)
], PaginationQueries.prototype, "limit", void 0);
__decorate([
    Field({
        description: "Paging the result.",
        rangeProps: { min: 1 },
    }),
    __metadata("design:type", Number)
], PaginationQueries.prototype, "page", void 0);
PaginationQueries = __decorate([
    Data({ relaxed: true })
], PaginationQueries);
export { PaginationQueries };
let SearchQueries = class SearchQueries {
    search;
};
__decorate([
    Field({
        description: "Search value for searchable fields.",
    }),
    __metadata("design:type", String)
], SearchQueries.prototype, "search", void 0);
SearchQueries = __decorate([
    Data({ relaxed: true })
], SearchQueries);
export { SearchQueries };
let LocaleQueries = class LocaleQueries {
    locale;
};
__decorate([
    Field({
        description: "Language code",
    }),
    __metadata("design:type", String)
], LocaleQueries.prototype, "locale", void 0);
LocaleQueries = __decorate([
    Data({ relaxed: true })
], LocaleQueries);
export { LocaleQueries };
let ReturningQueries = class ReturningQueries {
    returning;
};
__decorate([
    Field({
        description: "Whether to return ids of modified instances",
    }),
    __metadata("design:type", Boolean)
], ReturningQueries.prototype, "returning", void 0);
ReturningQueries = __decorate([
    Data({ relaxed: true })
], ReturningQueries);
export { ReturningQueries };
let GetManyQueries = class GetManyQueries extends select(PaginationQueries).combine(SearchQueries).combine(LocaleQueries).get() {
    fields;
    order;
    projection;
};
__decorate([
    Field({
        description: "Filter records by fields.",
    }),
    __metadata("design:type", Object)
], GetManyQueries.prototype, "fields", void 0);
__decorate([
    Field({
        description: "Order the result by fields.",
        rangeProps: { min: 1 },
    }),
    __metadata("design:type", Object)
], GetManyQueries.prototype, "order", void 0);
__decorate([
    Field({
        description: "Only return fields in this projection array.",
        vectorProps: { minLength: 1 },
    }),
    __metadata("design:type", Array)
], GetManyQueries.prototype, "projection", void 0);
GetManyQueries = __decorate([
    Data({ relaxed: true })
], GetManyQueries);
export { GetManyQueries };
let GetManyResponseBody = class GetManyResponseBody {
    total;
    records = [];
};
__decorate([
    Field({
        description: "Total number of found records.",
        isRequired: true,
    }),
    __metadata("design:type", Number)
], GetManyResponseBody.prototype, "total", void 0);
__decorate([
    Field({
        description: "The records in return.",
        isRequired: true,
        vectorProps: { elementDataType: DataType.OBJECT },
    }),
    __metadata("design:type", Array)
], GetManyResponseBody.prototype, "records", void 0);
GetManyResponseBody = __decorate([
    Data()
], GetManyResponseBody);
export { GetManyResponseBody };
//-- update & delete
let UpdateManyQueries = class UpdateManyQueries extends ReturningQueries {
    fields;
};
__decorate([
    Field({
        description: "The fields and corresponding values to filter",
    }),
    __metadata("design:type", Object)
], UpdateManyQueries.prototype, "fields", void 0);
UpdateManyQueries = __decorate([
    Data({ relaxed: true })
], UpdateManyQueries);
export { UpdateManyQueries };
let UpdateManyResponse = class UpdateManyResponse {
    modified;
};
__decorate([
    Field({
        description: "Array of ids of modified records",
        isRequired: true,
    }),
    __metadata("design:type", Array)
], UpdateManyResponse.prototype, "modified", void 0);
UpdateManyResponse = __decorate([
    Data()
], UpdateManyResponse);
export { UpdateManyResponse };
let UpdateManyBody = class UpdateManyBody {
    update = {};
};
__decorate([
    Field({
        description: "Update data",
        isRequired: true,
    }),
    __metadata("design:type", Object)
], UpdateManyBody.prototype, "update", void 0);
UpdateManyBody = __decorate([
    Data()
], UpdateManyBody);
export { UpdateManyBody };
let UpdateRecordsBody = class UpdateRecordsBody {
    records;
};
UpdateRecordsBody = __decorate([
    Data()
], UpdateRecordsBody);
export { UpdateRecordsBody };
