import { LogLevel } from "./LogLevel";
import { ILogMedium } from "./media/ILogMedium";
export interface LogHandler {
    log: (level: LogLevel, ...content: any[]) => void;
}
export declare abstract class AbstractLogger implements LogHandler {
    protected readonly limit: LogLevel;
    protected readonly logMedia: ILogMedium[];
    constructor(limit: LogLevel, logMedia: ILogMedium[]);
    protected abstract serializeContent(logLevel: LogLevel, ...content: any[]): string;
    protected getLogContext(): string;
    log(level: LogLevel, ...content: any[]): string;
    debug(...content: any[]): string;
    info(...content: any[]): string;
    warn(...content: any[]): string;
    error(...content: any[]): string;
}
