import { LOG_CONTEXT } from "../common/constants";
import { LogLevel } from "./LogLevel";
export class AbstractLogger {
    limit;
    logMedia;
    constructor(limit, logMedia) {
        this.limit = limit;
        this.logMedia = logMedia;
        this.limit = limit;
        this.logMedia = logMedia;
    }
    getLogContext() {
        return this[LOG_CONTEXT] || "";
    }
    log(level, ...content) {
        if (level < this.limit) {
            return "";
        }
        const logContent = this.serializeContent(level, content);
        for (const medium of this.logMedia) {
            medium.write(level, logContent);
        }
        return logContent;
    }
    debug(...content) {
        return this.log(LogLevel.DEBUG, ...content);
    }
    info(...content) {
        return this.log(LogLevel.INFO, ...content);
    }
    warn(...content) {
        return this.log(LogLevel.WARN, ...content);
    }
    error(...content) {
        return this.log(LogLevel.ERROR, ...content);
    }
}
