import { AbstractConstructor, Constructor } from "../common/types";
import { AbstractProvider } from "../di/AbstractProvider";
export declare const _: (name: string, code: number) => (message?: string) => {
    name: string;
    code: number;
    message: string | undefined;
};
export declare const Errors: {
    SYSTEM_ERROR: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    QUERY_ERROR: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    CANNOT_LOCK: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    VALIDATION_ERROR: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    ACCESS_DENIED: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    TFA_REQUIRED: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    SESSION_EXPIRED: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    NOT_FOUND: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    HTTP_REQUEST_ERROR: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    BAD_STATE: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    TOKEN_EXPIRED: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    INVALID_TOKEN: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    QUERY_UNIQUE_CONSTRAINT: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    QUERY_CASCADE_RESTRICTION: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    INVALID_CREDENTIALS: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
    REQUEST_RATE_LIMIT: (message?: string) => {
        name: string;
        code: number;
        message: string | undefined;
    };
};
export declare class ErrorBuilder {
    static forConfigNotFound(configName: string): {
        name: string;
        code: number;
        message: string | undefined;
    };
    static forTransientUsedWithInitable(constructorFn: Constructor<any>): {
        name: string;
        code: number;
        message: string | undefined;
    };
    static forInvalidInjection(message: string): {
        name: string;
        code: number;
        message: string | undefined;
    };
    static forInjectionCircularDependency(constructorFns: AbstractConstructor<any>[]): {
        name: string;
        code: number;
        message: string | undefined;
    };
    static forInjectionNotFound(constructorFn: AbstractConstructor<any>): {
        name: string;
        code: number;
        message: string | undefined;
    };
    static forMutipleInjectionsFound(constructorFn: AbstractConstructor<any>, candidates: Constructor<any>[]): {
        name: string;
        code: number;
        message: string | undefined;
    };
    static forMutipleProvidersFound(constructorFn: AbstractConstructor<any>, candidates: Constructor<AbstractProvider<any>>[]): {
        name: string;
        code: number;
        message: string | undefined;
    };
}
